/* ***********************************************************
 * This file was automatically generated on 2013-01-22.      *
 *                                                           *
 * Bindings Version 2.0.0                                    *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for output of voltage between 0 and 5V
	/// </summary>
	public class BrickletAnalogOut : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>
		/// </summary>
		public static int DEVICE_IDENTIFIER = 220;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletAnalogOut.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_VOLTAGE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletAnalogOut.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_VOLTAGE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletAnalogOut.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_MODE = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletAnalogOut.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_MODE = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletAnalogOut.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public static byte MODE_ANALOG_VALUE = 0;

		/// <summary>
		/// </summary>
		public static byte MODE_1K_TO_GROUND = 1;

		/// <summary>
		/// </summary>
		public static byte MODE_100K_TO_GROUND = 2;

		/// <summary>
		/// </summary>
		public static byte MODE_500K_TO_GROUND = 3;


		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletAnalogOut(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 0;


			responseExpected[FUNCTION_SET_VOLTAGE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_VOLTAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MODE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MODE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
		}

		/// <summary>
		///  Sets the voltage in mV. The possible range is 0V to 5V (0-5000).
		///  Calling this function will set the mode to 0 (see <see cref="Tinkerforge.BrickletAnalogOut.SetMode"/>).
		///  
		///  The default value is 0 (with mode 1).
		/// </summary>
		public void SetVoltage(int voltage)
		{
			byte[] data_ = MakePacketHeader(10, FUNCTION_SET_VOLTAGE);
			LEConverter.To((short)voltage, 8, data_);

			if(GetResponseExpected(FUNCTION_SET_VOLTAGE))
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_VOLTAGE, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the voltage as set by <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/>.
		/// </summary>
		public int GetVoltage()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_VOLTAGE);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_VOLTAGE, out response);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the mode of the analog value. Possible modes:
		///  
		///  * 0: Normal Mode (Analog value as set by <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/> is applied)
		///  * 1: 1k Ohm resistor to ground
		///  * 2: 100k Ohm resistor to ground
		///  * 3: 500k Ohm resistor to ground
		///  
		///  Setting the mode to 0 will result in an output voltage of 0. You can jump
		///  to a higher output voltage directly by calling <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/>.
		///  
		///  The default mode is 1.
		/// </summary>
		public void SetMode(byte mode)
		{
			byte[] data_ = MakePacketHeader(9, FUNCTION_SET_MODE);
			LEConverter.To((byte)mode, 8, data_);

			if(GetResponseExpected(FUNCTION_SET_MODE))
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_MODE, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the mode as set by <see cref="Tinkerforge.BrickletAnalogOut.SetMode"/>.
		/// </summary>
		public byte GetMode()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_MODE);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_MODE, out response);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifiers can be found :ref:`here &lt;device_identifier&gt;`.
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_IDENTITY);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_IDENTITY, out response);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}
	}
}